Open CASCADE Technology: RWStepAP214_GeneralModule Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
RWStepAP214_GeneralModule Class Reference

Defines General Services for StepAP214 Entities (Share,Check,Copy; Trace already inherited) Depends (for case numbers) of Protocol from StepAP214. More...

`#include <RWStepAP214_GeneralModule.hxx>`

Inheritance diagram for RWStepAP214_GeneralModule:
[legend]

## Public Member Functions
| RWStepAP214_GeneralModule ()
| Creates a GeneralModule. More...
void | FillSharedCase (const Standard_Integer CN, const Handle< Standard_Transient > &ent, Interface_EntityIterator &iter) const
| Specific filling of the list of Entities shared by an Entity <ent>, according to a Case Number <CN> (provided by StepAP214 Protocol). More...
void | CheckCase (const Standard_Integer CN, const Handle< Standard_Transient > &ent, const Interface_ShareTool &shares, Handle< Interface_Check > &ach) const
| Specific Checking of an Entity <ent> More...
void | CopyCase (const Standard_Integer CN, const Handle< Standard_Transient > &entfrom, const Handle< Standard_Transient > &entto, Interface_CopyTool &TC) const
| Specific Copy ("Deep") from <entfrom> to <entto> (same type) by using a CopyTool which provides its working Map. Use method Transferred from CopyTool to work. More...
Standard_Boolean | NewVoid (const Standard_Integer CN, Handle< Standard_Transient > &ent) const
| Creates a new void entity <entto> according to a Case Number This entity remains to be filled, by reading from a file or by copying from another entity of same type (see CopyCase) More...
virtual Standard_Integer | CategoryNumber (const Standard_Integer CN, const Handle< Standard_Transient > &ent, const Interface_ShareTool &shares) const
| Returns a category number which characterizes an entity Category Numbers are managed by the class Category <shares> can be used to evaluate this number in the context Default returns 0 which means "unspecified". More...
virtual Handle< TCollection_HAsciiString > | Name (const Standard_Integer CN, const Handle< Standard_Transient > &ent, const Interface_ShareTool &shares) const
| Returns the name of a STEP Entity according to its type. More...
Public Member Functions inherited from Interface_GeneralModule
virtual void | FillShared (const Handle< Interface_InterfaceModel > &model, const Standard_Integer CN, const Handle< Standard_Transient > &ent, Interface_EntityIterator &iter) const
| Specific filling of the list of Entities shared by an Entity <ent>, according a Case Number <CN> (formerly computed by CaseNum), considered in the context of a Model <model> Default calls FillSharedCase (i.e., ignores the model) Can be redefined to use the model for working. More...
void | Share (Interface_EntityIterator &iter, const Handle< Standard_Transient > &shared) const
| Adds an Entity to a Shared List (uses GetOneItem on <iter>) More...
virtual void | ListImplied (const Handle< Interface_InterfaceModel > &model, const Standard_Integer CN, const Handle< Standard_Transient > &ent, Interface_EntityIterator &iter) const
| List the Implied References of <ent> considered in the context of a Model <model> : i.e. the Entities which are Referenced while not considered as Shared (not copied if <ent> is, references not renewed by CopyCase but by ImpliedCase, only if referenced Entities have been Copied too) FillShared + ListImplied give the complete list of References Default calls ListImpliedCase (i.e. ignores the model) Can be redefined to use the model for working. More...
virtual void | ListImpliedCase (const Standard_Integer CN, const Handle< Standard_Transient > &ent, Interface_EntityIterator &iter) const
| List the Implied References of <ent> (see above) are Referenced while not considered as Shared (not copied if <ent> is, references not renewed by CopyCase but by ImpliedCase, only if referenced Entities have been Copied too) FillSharedCase + ListImpliedCase give the complete list of Referenced Entities The provided default method does nothing (Implied References are specific of a little amount of Entity Classes). More...
virtual Standard_Boolean | CanCopy (const Standard_Integer CN, const Handle< Standard_Transient > &ent) const
| Specific answer to the question "is Copy properly implemented" Remark that it should be in phase with the implementation of NewVoid+CopyCase/NewCopyCase Default returns always False, can be redefined. More...
virtual Standard_Boolean | Dispatch (const Standard_Integer CN, const Handle< Standard_Transient > &entfrom, Handle< Standard_Transient > &entto, Interface_CopyTool &TC) const
| Dispatches an entity Returns True if it works by copy, False if it just duplicates the starting Handle. More...
virtual Standard_Boolean | NewCopiedCase (const Standard_Integer CN, const Handle< Standard_Transient > &entfrom, Handle< Standard_Transient > &entto, Interface_CopyTool &TC) const
| Specific operator (create+copy) defaulted to do nothing. It can be redefined : When it is not possible to work in two steps (NewVoid then CopyCase). This can occur when there is no default constructor : hence the result <entto> must be created with an effective definition. Remark : if NewCopiedCase is defined, CopyCase has nothing to do Returns True if it has produced something, false else. More...
virtual void | RenewImpliedCase (const Standard_Integer CN, const Handle< Standard_Transient > &entfrom, const Handle< Standard_Transient > &entto, const Interface_CopyTool &TC) const
| Specific Copying of Implied References A Default is provided which does nothing (must current case !) Already copied references (by CopyFrom) must remain unchanged Use method Search from CopyTool to work. More...
virtual void | WhenDeleteCase (const Standard_Integer CN, const Handle< Standard_Transient > &ent, const Standard_Boolean dispatched) const
| Prepares an entity to be deleted. What does it mean : Basically, any class of entity may define its own destructor By default, it does nothing but calling destructors on fields With the Memory Manager, it is useless to call destructor, it is done automatically when the Handle is nullified(cleared) BUT this is ineffective in looping structures (whatever these are "Implied" references or not). More...
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Detailed Description

Defines General Services for StepAP214 Entities (Share,Check,Copy; Trace already inherited) Depends (for case numbers) of Protocol from StepAP214.

## Constructor & Destructor Documentation

RWStepAP214_GeneralModule::RWStepAP214_GeneralModule | ( |  | ) |

Creates a GeneralModule.

## Member Function Documentation

virtual Standard_Integer RWStepAP214_GeneralModule::CategoryNumber | ( | const Standard_Integer | CN,
|  | const Handle< Standard_Transient > & | ent,
|  | const Interface_ShareTool & | shares
| ) |  | const
| virtual

Returns a category number which characterizes an entity Category Numbers are managed by the class Category <shares> can be used to evaluate this number in the context Default returns 0 which means "unspecified".

Reimplemented from Interface_GeneralModule.

void RWStepAP214_GeneralModule::CheckCase | ( | const Standard_Integer | CN,
|  | const Handle< Standard_Transient > & | ent,
|  | const Interface_ShareTool & | shares,
|  | Handle< Interface_Check > & | ach
| ) |  | const
| virtual

Specific Checking of an Entity <ent>

Implements StepData_GeneralModule.

void RWStepAP214_GeneralModule::CopyCase | ( | const Standard_Integer | CN,
|  | const Handle< Standard_Transient > & | entfrom,
|  | const Handle< Standard_Transient > & | entto,
|  | Interface_CopyTool & | TC
| ) |  | const
| virtual

Specific Copy ("Deep") from <entfrom> to <entto> (same type) by using a CopyTool which provides its working Map. Use method Transferred from CopyTool to work.

Implements StepData_GeneralModule.

void RWStepAP214_GeneralModule::FillSharedCase | ( | const Standard_Integer | CN,
|  | const Handle< Standard_Transient > & | ent,
|  | Interface_EntityIterator & | iter
| ) |  | const
| virtual

Specific filling of the list of Entities shared by an Entity <ent>, according to a Case Number <CN> (provided by StepAP214 Protocol).

Implements StepData_GeneralModule.

virtual Handle< TCollection_HAsciiString > RWStepAP214_GeneralModule::Name | ( | const Standard_Integer | CN,
|  | const Handle< Standard_Transient > & | ent,
|  | const Interface_ShareTool & | shares
| ) |  | const
| virtual

Returns the name of a STEP Entity according to its type.

Reimplemented from Interface_GeneralModule.

Standard_Boolean RWStepAP214_GeneralModule::NewVoid | ( | const Standard_Integer | CN,
|  | Handle< Standard_Transient > & | entto
| ) |  | const
| virtual

Creates a new void entity <entto> according to a Case Number This entity remains to be filled, by reading from a file or by copying from another entity of same type (see CopyCase)

Implements Interface_GeneralModule.

The documentation for this class was generated from the following file:

- RWStepAP214_GeneralModule.hxx